# Language Reference

This section provides information on the syntax of the Ballerina language and how to write a program. If you haven't already familiarized yourself with the [Key Concepts](../key-concepts.md) of Ballerina, take a moment to do that now. You should also walk through the [Quick Tour](../quick-tour.md) and [Write your First Program](../tutorials/first-program.md) tutorial. 

To begin, read the [Overview](lang-overview.md). You can then read through the following topics to learn the details of each area:

- [Packaging and Running Programs](packaging.md)
- [Services](services.md)
- [Resources](resources.md)
- [Functions](functions.md)
- [Connectors](connectors.md)
- [Remote Functions](remote-functions.md)
- [Workers](workers.md)
- [Types and Variables](types-variables.md)
- [Statements](statements.md)
